// 6.05.2007   
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//|                                               BrainTrend1Sig.mq4 |
//|                                         BrainTrend Black edition |
//|                                      http://www.braintrading.com |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
#property copyright "BrainTrend Black edition"
#property link      "http://www.braintrading.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Aqua
//---- input parameters
extern int       EnableAlerts=0;
extern int       SignalID=0;
extern int       CountBars=500;
extern int SSAPrice                =  PRICE_CLOSE;
extern int SSALag                  =  25;
extern int SSANumberOfComputations =   2;
extern int SSANumberOfBars         = 300;
extern int FirstBar                = 300; 

extern int       f            = 7;
extern int       s            = 1.5;
extern int       x1           = 80;
extern int       x2           = 20;
extern int       d            = 2.3;
extern int       value11      = 9;
extern int       Slowing = 1;
extern int       JStoPhase = 1;

//---- buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
//---- 
int    shift,limit,p,a1,tsig;
double value2,value3,Range,Range1,Range2,val1,val2,val3;
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator initialization function                         |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int init()
  {
//---- indicator 0
   SetIndexStyle (0,DRAW_ARROW);
   SetIndexArrow (0,108);
   SetIndexBuffer(0,Ind_Buffer1);
   SetIndexEmptyValue(0,0.0);
//---- indicator 1  
   SetIndexStyle (1,DRAW_ARROW);
   SetIndexArrow (1,108);
   SetIndexBuffer(1,Ind_Buffer2);
   SetIndexEmptyValue(1,0.0);
//----
   string short_name;
   short_name="BrainTrend1Sig";
   IndicatorShortName(short_name);
   SetIndexLabel(0,""+short_name+"_SELL");
   SetIndexLabel(1,""+short_name+"_BUY" );
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- 

   return(0);
  }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator iteration function                              |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int start()
  {
   double CloseVal, CloseVal2, HighVal, LowVal;
   int    counted_bars=IndicatorCounted();
   if (Bars < 11)return(0);
   if (CountBars > Bars-1-11)CountBars=Bars-1-11;
//----  
   limit = CountBars;//-counted_bars-1 
//----  
   shift=limit;
   p=0;
//---- 
while(shift>=0)

      {
      Range = iATR(NULL,0,f,shift);
      Range1 = Range / d;
      Range2 = Range * s / 4;
      value2 = iCustom(Symbol(),Period(),"JStochastic",value11,value11,Slowing,JStoPhase,0,shift);
      
      CloseVal  = NormalizeDouble(iCustom(Symbol(),Period(),"SSA end-pointed",SSAPrice,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,0,shift),Digits);
      CloseVal2 = NormalizeDouble(iCustom(Symbol(),Period(),"SSA end-pointed",SSAPrice,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,0,shift + 2),Digits);
      HighVal = NormalizeDouble(iCustom(Symbol(),Period(),"SSA end-pointed",PRICE_HIGH,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,0,shift),Digits);
      LowVal  = NormalizeDouble(iCustom(Symbol(),Period(),"SSA end-pointed",PRICE_LOW,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,0,shift),Digits);
      
      val1 = 0;
      val2 = 0;
      val3 = MathAbs(CloseVal - CloseVal2);
      if (value2 < x2 && val3 > Range1&&(p == 2 || p == 0)) 
            {
            value3 = HighVal + Range2;
            val1 = value3;
            p = 1;
            }       
      if (value2 > x1 && val3 > Range1&&(p == 1 || p == 0)) 
            {
            value3 = LowVal - Range2;
            val2 = value3;
            p = 2;
            }
      Ind_Buffer1[shift]=val1;
      Ind_Buffer2[shift]=val2;  
    
       shift--;
      }
if (EnableAlerts == 1 && val1 > 0 && tsig != 1) 
      {
      tsig = 1;
      a1 = FileOpen("alert1" + SignalID,";");
      FileWrite(a1,"Sell ", Symbol(), " at ", Close[0], " S/L ", val1, " BT1 M", Period());
      FileClose(a1);
      }
if (EnableAlerts == 1 && val1 > 0 && tsig != 2) 
      {
      tsig = 2;
      a1 = FileOpen("alert1" + SignalID,";");
      FileWrite(a1,"Buy ",  Symbol(), " at ", Close[0]," S/L ", val2, " BT1 M",  Period());
      FileClose(a1);
      }
//----
   return(0);
  }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+